| AI Engine Intrinsics User Guide (AIE) v2025.2

Loading...
Searching...
No Matches
Functions
Z buffer conjugation
Intrinsics » Vector Operations » MAC intrinsics » Multiplication » Advanced » Integer » Vector MAC » 32 bit x 32 bit » 32 bit Complex x 32 bit Complex

## Overview

32 bit complex by 32 bit complex using Z buffer conjugation

## Functions
v2cacc80 | lmac2_nc (v2cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-accumulate intrinsic function with z buffer conjugation .
v2cacc80 | lmac2_nc (v2cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-accumulate intrinsic function with z buffer conjugation using small X input buffer.
v2cacc80 | lmsc2_nc (v2cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-subtract intrinsic function with z buffer conjugation .
v2cacc80 | lmsc2_nc (v2cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-subtract intrinsic function with z buffer conjugation using small X input buffer.
v2cacc80 | lmul2_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply intrinsic function with z buffer conjugation .
v2cacc80 | lmul2_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply intrinsic function with z buffer conjugation using small X input buffer.
v2cacc80 | lnegmul2_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-negate intrinsic function with z buffer conjugation .
v2cacc80 | lnegmul2_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v4cint32 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-negate intrinsic function with z buffer conjugation using small X input buffer.

## Function Documentation

## ◆ lmac2_nc() [1/2]

v2cacc80 lmac2_nc | ( | v2cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-accumulate intrinsic function with z buffer conjugation .

acc0 += cnj(z00)*x00
acc1 += cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (2 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmac2_nc() [2/2]

v2cacc80 lmac2_nc | ( | v2cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-accumulate intrinsic function with z buffer conjugation using small X input buffer.

acc0 += cnj(z00)*x00
acc1 += cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (2 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc2_nc() [1/2]

v2cacc80 lmsc2_nc | ( | v2cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-subtract intrinsic function with z buffer conjugation .

acc0 -= cnj(z00)*x00
acc1 -= cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (2 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc2_nc() [2/2]

v2cacc80 lmsc2_nc | ( | v2cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-subtract intrinsic function with z buffer conjugation using small X input buffer.

acc0 -= cnj(z00)*x00
acc1 -= cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (2 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul2_nc() [1/2]

v2cacc80 lmul2_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply intrinsic function with z buffer conjugation .

acc0 = cnj(z00)*x00
acc1 = cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul2_nc() [2/2]

v2cacc80 lmul2_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply intrinsic function with z buffer conjugation using small X input buffer.

acc0 = cnj(z00)*x00
acc1 = cnj(z10)*x10

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul2_nc() [1/2]

v2cacc80 lnegmul2_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-negate intrinsic function with z buffer conjugation .

acc0 = -( cnj(z00)*x00 )
acc1 = -( cnj(z10)*x10 )

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul2_nc() [2/2]

v2cacc80 lnegmul2_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v4cint32 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex multiply-negate intrinsic function with z buffer conjugation using small X input buffer.

acc0 = -( cnj(z00)*x00 )
acc1 = -( cnj(z10)*x10 )

Returns
  Returned accumulation vector (2 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 4 elements of type cint32
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.